import { listeners } from './ActionListener';
export const ConfigMiddleware = {
    initialized: false,
    suffixes: {
        request: 'REQUESTED',
        success: 'SUCCEEDED',
        failure: 'FAILED',
    },
};
const isAsyncAction = (config, action) => action.type.endsWith(config.request) ||
    action.type.endsWith(config.success) ||
    action.type.endsWith(config.failure);
export const dispatchAsyncMiddleware = (config) => () => next => action => {
    try {
        if (config && !ConfigMiddleware.initialized) {
            ConfigMiddleware.suffixes = config;
            ConfigMiddleware.initialized = true;
        }
        if (isAsyncAction(ConfigMiddleware.suffixes, action) &&
            Object.keys(listeners).length > 0) {
            for (const listener of Object.values(listeners)) {
                listener(action);
            }
        }
    }
    catch (error) {
        console.error(error);
    }
    return next(action);
};
//# sourceMappingURL=DispatchAsyncMiddleware.js.map