import { addActionListener } from './ActionListener';
import { ConfigMiddleware } from './DispatchAsyncMiddleware';
export function dispatchAsync(dispatch, action) {
    return new Promise(resolve => {
        const actionNameBase = action.type.replace(`_${ConfigMiddleware.suffixes.request}`, '');
        const unsubscribe = addActionListener((resultAction) => {
            if (resultAction.type ===
                `${actionNameBase}_${ConfigMiddleware.suffixes.success}`) {
                resolve({
                    success: true,
                    result: resultAction.payload,
                });
                unsubscribe();
            }
            else if (resultAction.type ===
                `${actionNameBase}_${ConfigMiddleware.suffixes.failure}`) {
                const error = resultAction.payload instanceof Error
                    ? resultAction
                    : new Error(`Action failure: ${actionNameBase}`);
                resolve({ success: false, error });
                unsubscribe();
            }
        });
        dispatch(action);
    });
}
//# sourceMappingURL=dispatchAsync.js.map